unit sDBEdit;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, sStyleUtil, db, sConst;

type
  TsDBEdit = class(TDBEdit)
  private
    { Private declarations }
    procedure NewAdjustHeight;

    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;

  protected
    FsStyle : TsStyleDB;

    procedure Loaded; override;
    procedure WndProc (var Message: TMessage); override;
  public
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
    { Public declarations }
    property BorderStyle default bsNone;
  published
    { Published declarations }
    property sStyle: TsStyleDB read FsStyle write FsStyle;
  end;

implementation

constructor TsDBEdit.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyleDB.Create(Self);
  sStyle.COC := COC_TsDBEdit;
//  sStyle.GetDataField := GetDataField;

  ParentFont := True;
  AutoSize := False;
  Ctl3D := False;
  ControlStyle := ControlStyle - [csFramed];
  BorderStyle := bsNone;

  OnKeyDown := sStyle.onKeyDown;
end;

procedure TsDBEdit.Loaded;
begin
  inherited;
  if not(csDesigning in ComponentState) then NewAdjustHeight;
end;

procedure TsDBEdit.NewAdjustHeight;
var
  DC: HDC;
  SaveFont: HFONT;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  Height := Metrics.tmHeight + 6;
end;

procedure TsDBEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  if sStyle.Flat then InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
end;

procedure TsDBEdit.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    NewAdjustHeight;
    if sStyle.Flat then begin
      BorderStyle := bsNone;
      Color := sStyle.GetActiveColor;
      if Assigned(Parent) then sStyle.redrawBorder;
    end
    else begin
      BorderStyle := bsSingle;
      Color := sStyle.GetActiveColor;
    end;
    inherited;
  end;
end;

procedure TsDBEdit.WndProc(var Message: TMessage);
begin
  sStyle.WndProc(Message);
  inherited;
end;

procedure TsDBEdit.WMNCPaint(var Message: TMessage);
begin
  if sStyle.Painting.Transparency = 0 then begin
    inherited;
  end;
  Color := sStyle.GetActiveColor;
  sStyle.RedrawBorder;
end;

end.
