unit sDateEdit;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

{$R sStyleRes.res}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, sStyleUtil, ToolEdit, CurrEdit, ComCtrls, 
  ToolWin, ExtCtrls, RXCtrls, sConst;

type

  TsDateEdit = class(TCustomDateEdit)
  private
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
    { Private declarations }
  protected
    FsStyle : TsStyle;

    { Protected declarations }
    procedure WndProc(var Message: TMessage); override;
  public
    LastControl : boolean;
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
    { Public declarations }
    property BorderStyle;
  published
    property EditMask;
    property AutoSelect;
    property Formatting;
    property HideSelection;
    property HelpContext;
    property OEMConvert;
    property PasswordChar;
    property ReadOnly;
    property Enabled;
    property Font;
    property Hint;
    property MaxLength;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Text;
    property Visible;
    property CharCase;
    property sStyle:TsStyle read FsStyle write FsStyle;

    property BlanksChar;
    property ButtonHint;
    property CalendarHints;
    property CheckOnExit;
    property ClickKey;
    property DefaultToday;
    property DialogTitle;
    property DirectInput;
    property DragCursor;
    property DragMode;
    property GlyphKind;
    property Glyph;
    property ButtonWidth;
    property NumGlyphs;
    property PopupAlign;
    property PopupColor;
    property CalendarStyle;
    property StartOfWeek;
    property Weekends;
    property WeekendColor;
    property YearDigits;
    property TabStop;
    property OnAcceptDate;
    property OnButtonClick;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
{$IFDEF RX_D5}
    property OnContextPopup;
{$ENDIF}
    property OnEnter;
    property OnExit;
    { Published declarations }
  end;

implementation

constructor TsDateEdit.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyle.Create(Self);
  sStyle.COC := COC_TsDateEdit;
//  ControlStyle := ControlStyle + [csOpaque, csDisplayDragImage];
  OnKeyDown := sStyle.onKeyDown;
  YearDigits := dyFour;
  Button.GrayedInactive := True;
//  Button.Glyph.Mask(clFuchsia);
//  Button.NumGlyphs := 2;
//  Button.Glyph.LoadFromResourceName(hInstance, 'BTN_DATE');
//  Glyph.Mask(clFuchsia);
//  Glyph.LoadFromResourceName(hInstance, 'BTN_DATE');

  Width := 84;
end;

procedure TsDateEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  if sStyle.Flat then begin
    if sStyle.ControlIsActive and (msBorder in sStyle.Selection.Mode) then begin
      InflateRect(Message.CalcSize_Params^.rgrc[0], 3 - sStyle.Selection.Border.Width, 3 - sStyle.Selection.Border.Width);
    end
    else begin
      InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
    end;
{
    InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
    Message.CalcSize_Params^.rgrc[0].Right := Message.CalcSize_Params^.rgrc[0].Right - ButtonWidth;
}
  end;
end;

procedure TsDateEdit.WMNCPaint(var Message: TMessage);
begin
  Color := sStyle.GetActiveColor;
  inherited;
  sStyle.RedrawBorder;
  Button.Repaint;
end;

procedure TsDateEdit.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    inherited;
    Self.UpdateMask;
    Color := sStyle.GetActiveColor;
    PopupColor := Color;
    Button.Flat := sStyle.Flat;
    Button.Transparent := sStyle.Flat;
    if sStyle.Flat then begin
      Button.Left := -3;
      Button.Top := -3;
      BorderStyle := bsNone;
      if Assigned(Parent) then begin
        sStyle.RedrawBorder;
        Button.Repaint;
      end;
    end
    else begin
      Button.Left := 0;
      Button.Top := 0;
      BorderStyle := bsSingle;
    end;
  end;
end;

procedure TsDateEdit.WndProc(var Message: TMessage);
begin
   sStyle.WndProc(Message);
   inherited;
end;

end.
